/* 
 This file was generated by Dashcode.  
 You may edit this file to customize your widget or web page 
 according to the license.txt file included in the project.
 */

// Properties set by attributes panel
var updateInterval;

// Monitor objects (see UsageMonitor.js)
var usageMonitor;
var monitorRunning;

// Max width for indicator bar
var barMaxWidth = 217;

//
// Function: initMonitor()
// Called by load() when widget starts up to set up and start the monitors
//
function initMonitors()
{
    var updateFunction = function(planText, peakQuota, offpeakQuota, peakUsed, offpeakUsed, daysRemaining) {
        var peakRemaining = peakQuota - peakUsed;
        var offpeakRemaining = offpeakQuota - offpeakUsed;
        var daysUsed = 30 - daysRemaining;
        var timeRatio = daysUsed/30;
        timeRatio = (timeRatio > 1.0 ? 1.0 : (timeRatio < 0 ? 0 : timeRatio));        
        
        hideElement("error");
        hideElement("spinner");
        
        setElementText("plan", planText);
        
        setElementText("peak-used", formatNumber(peakUsed));
        setElementText("peak-remaining", formatNumber(peakRemaining));
        setBarValue("peak-bar", peakUsed / peakQuota);
        
        setElementText("offpeak-used", formatNumber(offpeakUsed));
        setElementText("offpeak-remaining", formatNumber(offpeakRemaining));
        setBarValue("offpeak-bar", offpeakUsed / offpeakQuota);
        
        setElementText("time-remaining", daysRemaining+" days remaining");
        setBarValue("time-bar1", timeRatio);
        setBarValue("time-bar2", timeRatio);
    };

    var errorFunction = function(error) {
        hideElement("spinner");
        hideElement("plan");
        hideElement("peak-used");
        hideElement("peak-remaining");
        hideElement("peak-bar");
        hideElement("offpeak-used");
        hideElement("offpeak-remaining");
        hideElement("offpeak-bar");
        hideElement("time-remaining");
        hideElement("time-bar1");
        hideElement("time-bar1");
        
        setElementText("error", error);
    }

    var loadFunction = function() {
        showElement("spinner");
    }

    usageMonitor = new UsageMonitor(updateInterval, updateFunction);
    usageMonitor.onerror = errorFunction;
    usageMonitor.onload = loadFunction;
    usageMonitor.start();

    monitorRunning = true;
}

//
// Function: setElementText(elementName, elementValue)
// Set the text contents of an HTML div
//
// elementName: Name of the element in the DOM
// elementValue: Text to display in the element
//
function setElementText(elementName, elementValue)
{
    var element = document.getElementById(elementName);
    if (element) {
        element.innerText = elementValue;
        element.style.visibility = "visible";
    }
}

//
// Function: hideElement(elementName)
// Set the element to be hidden
//
// elementName: Name of the element in the DOM
//
function hideElement(elementName)
{
    var element = document.getElementById(elementName);
    if (element) {
        element.style.visibility = "hidden";
    }
}

//
// Function: showElement(elementName)
// Set the element to be visible
//
// elementName: Name of the element in the DOM
//
function showElement(elementName)
{
    var element = document.getElementById(elementName);
    if (element) {
        element.style.visibility = "visible";
    }
}


//
// Function: setBarValue(barId, value)
// Sets the value of one of the indicator bars
//
// barId: Bar to set
// value: Value to set gauge to (0..1)
//
function setBarValue (barId, value)
{
    var element = document.getElementById(barId);
    if (element != null) {
        if ( value < 0 ) value = 0;
        if ( value > 1 ) value = 1;
        var width = (barMaxWidth * value);
        if ( width < 7 ) width = 7;
        element.style.width = width + "px";
        element.style.visibility = 'visible';
    }
}


//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    dashcode.setupParts();

    // Get the properties
    updateInterval = +attributes.updateInterval;
    if (!updateInterval) {
        updateInterval = 1;
    }

    // Set up command monitors
    initMonitors();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    if ( monitorRunning ) {
        usageMonitor.stop();
    }
    
    // Remove any preferences as needed
    widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("username"));
    widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("password"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop monitor timers to prevent CPU usage
    if (monitorRunning) {
        usageMonitor.stop();
        monitorRunning = false;
    }
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
    if (monitorRunning === false) {
        usageMonitor.start();
        monitorRunning = true;
    }
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var username = widget.preferenceForKey(dashcode.createInstancePreferenceKey("username"));
    var password = widget.preferenceForKey(dashcode.createInstancePreferenceKey("password"));
    document.getElementById('username').value = (username ? username : "");
    document.getElementById('password').value = (password ? password : "");

    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display="none";
    back.style.display="block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
    
    document.getElementById('username').focus();
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    widget.setPreferenceForKey(document.getElementById('username').value, dashcode.createInstancePreferenceKey("username"));
    widget.setPreferenceForKey(document.getElementById('password').value, dashcode.createInstancePreferenceKey("password"));

    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
    
    usageMonitor.update();
}

if (window.widget)
{
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
}


function onLogoClick(event)
{
    widget.openURL('http://tzisoftware.com');
}


function formatNumber(number) {
    if ( Math.abs(number) >= 1073741824 ) {
        number /= 1073741824;
        return number.toFixed(2).replace(/\.?0+$/, "") + " Gb";
    } else if ( Math.abs(number) >= 1048576 ) {
        number /= 1048576;
        return number.toFixed(2).replace(/\.?0+$/, "") + " Mb";
    } else if ( Math.abs(number) >= 1024 ) {
        number /= 1024;
        return number.toFixed(2).replace(/\.?0+$/, "") + " Kb";
    } else {
        return number + " B";
    }
}